import { ElementRef, OnChanges, OnDestroy, SimpleChanges } from '@angular/core';
import { NgxMaterialTimepickerComponent } from '../ngx-material-timepicker.component';
import { ControlValueAccessor } from '@angular/forms';
import { Moment } from 'moment';
export declare class TimepickerDirective implements ControlValueAccessor, OnDestroy, OnChanges {
    private elementRef;
    disabled: boolean;
    disableClick: boolean;
    onTouched: () => void;
    private timepickerSubscriptions;
    private onChange;
    constructor(elementRef: ElementRef);
    private _timepicker;
    timepicker: NgxMaterialTimepickerComponent;
    private _format;
    format: number;
    private _min;
    min: string | Moment;
    private _max;
    max: string | Moment;
    private _minuteIncrements;
    minuteIncrements: number;
    private _value;
    value: string;
    private defaultTime;
    onInput(value: string): void;
    ngOnChanges(changes: SimpleChanges): void;
    onClick(event: any): void;
    writeValue(value: string): void;
    registerOnChange(fn: (value: any) => void): void;
    registerOnTouched(fn: () => void): void;
    setDisabledState(isDisabled: boolean): void;
    ngOnDestroy(): void;
    private registerTimepicker(picker);
    private updateInputValue();
    private isValueAvailableToUpdate();
}
